Abc/Abc.Northwind.MvcWebUI/Controllers/CartController.cs
using Abc.Northwind.Business.Abstract;
using Abc.Northwind.Entities.Concrete;
using Abc.Northwind.MvcWebUI.Models;
using Abc.Northwind.MvcWebUI.Services;
using Abc.Northwind.MvcWebUI.ViewComponents;
using Microsoft.AspNetCore.Mvc;

namespace Abc.Northwind.MvcWebUI.Controllers
{
    public class CartController : Controller
    {
        private ICartSessionService _cartSessionService;
        private ICartService _cartService;
        private IProductService _productService;

        public CartController(IProductService productService, ICartService cartService, ICartSessionService cartSessionService)
        {
            _productService = productService;
            _cartService = cartService;
            _cartSessionService = cartSessionService;
        }

        public IActionResult AddToCart(int productId)
        {
            var productToBeAdded = _productService.GetById(productId);

            var cart = _cartSessionService.GetCart();

            _cartService.AddToCart(cart, productToBeAdded);

            _cartSessionService.SetCart(cart);

            TempData.Add("message", string.Format("Your product, {0}, was successfully added to the cart!", productToBeAdded.ProductName));

            return RedirectToAction("Index", "Product");
        }

        public IActionResult List()
        {
            var cart = _cartSessionService.GetCart();

            CartSummaryViewModel cartSummaryViewModel= new CartSummaryViewModel
            {
                Cart = cart
            };
            return View(cartSummaryViewModel);
        }

        public IActionResult Remove(int productId)
        {
            var cart = _cartSessionService.GetCart();

            //var cartLine = cart.CartLines.FirstOrDefault(p=>p.Product.ProductId== productId);

            //cart.CartLines.Remove(cartLine);

            _cartService.RemoveFromCart(cart, productId);

            _cartSessionService.SetCart(cart);

            TempData.Add("message", string.Format("Your product was successfully deleted from the cart!"));

            return RedirectToAction("List");
            //return View();
        }

        public IActionResult Complete()
        {
            //Category category = new Category();
            var shippingDetailsViewModel = new ShippingDetailsViewModel
            {
                ShippingDetails = new ShippingDetails()
            };

            //return View(shippingDetailsViewModel);
            return View(shippingDetailsViewModel);
            //return View(category);
        }
        [HttpPost]
        public IActionResult Complete(ShippingDetails shippingDetails)
        //public IActionResult Complete(Category category)
        {
            if(!ModelState.IsValid)
            {
                return View();
            }
            TempData.Add("message", string.Format("Thank you {0}, your order is processing", shippingDetails.FirstName));
            return View();
        }
     }
}

Abc/Abc.Northwind.MvcWebUI/Views/Cart/Complete.cshtml
@model Abc.Northwind.MvcWebUI.Models.ShippingDetailsViewModel
@*@model Abc.Northwind.Entities.Concrete.Category*@
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
    Layout = "~/Views/_Layout.cshtml";
}

<h2>Shipping Details</h2>

<form asp-controller="Cart" asp-action="Complete" method="post">
    <div class="form-group">
        <label asp-for="ShippingDetails.FirstName"></label>
        <input asp-for="@Model.ShippingDetails.FirstName" class="form-control" placeholder="First Name" />
        <span asp-validation-for="@Model.ShippingDetails.FirstName"></span>
    </div>
    <div class="form-group">
        <label asp-for="ShippingDetails.LastName"></label>
        <input asp-for="@Model.ShippingDetails.LastName" class="form-control" placeholder="Last Name" />
        <span asp-validation-for="@Model.ShippingDetails.LastName"></span>
    </div> <div class="form-group">
        <label asp-for="ShippingDetails.City"></label>
        <input asp-for="@Model.ShippingDetails.City" class="form-control" placeholder="City" />
        <span asp-validation-for="@Model.ShippingDetails.City"></span>
    </div>
    <div class="form-group">
        <label asp-for="ShippingDetails.Address"></label>
        <input asp-for="@Model.ShippingDetails.Address" class="form-control" placeholder="Address" />
        <span asp-validation-for="@Model.ShippingDetails.Address"></span>
    </div>
    <div class="form-group">
        <label asp-for="ShippingDetails.Email"></label>
        <input asp-for="@Model.ShippingDetails.Email" class="form-control" placeholder="Email" />
        <span asp-validation-for="@Model.ShippingDetails.Email"></span>
    </div> <div class="form-group">
        <label asp-for="ShippingDetails.Age"></label>
        <input asp-for="@Model.ShippingDetails.Age" class="form-control" placeholder="Age" />
        <span asp-validation-for="@Model.ShippingDetails.Age"></span>
    </div>
   @* </div> <div class="form-group">
        <label asp-for="CategoryId"></label>
        <input asp-for="@Model.CategoryId" class="form-control" placeholder="Age" />
        <span asp-validation-for="@Model.CategoryId"></span>
    </div>*@
    <input type="submit" value="Complete Shopping" class="btn btn-sm btn-outline-success"/>
</form>

Abc/Abc.Northwind.MvcWebUI/Views/Cart/List.cshtml
@model CartSummaryViewModel
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
    Layout = "~/Views/_Layout.cshtml";
}

<h2>Your Cart</h2>
<table class="table">
    <tr>
        <td>Product Name</td>
        <td>Unit Price</td>
        <td>Units In Stock</td>
        <td>Quantity</td>
        <td></td>
    </tr>
    @foreach(var item in Model.Cart.CartLines)
    {
        <tr>
            <td>@item.Product.ProductName</td>
            <td>@item.Product.UnitPrice</td>
            <td>@item.Product.UnitsInStock</td>
            <td>@item.Quantity</td>
            <td class="text-right"><a class="btn btn-sm btn-danger" asp-controller="Cart" asp-action="Remove" asp-route-productId="@item.Product.ProductId"><span></span>remove from cart</a></td>
        </tr>
    }
    <tr>
        <td></td>
        <td></td>
        <td></td>
        <td>
            <h3>Total</h3>
        </td>
        <td class="text-right">
            <h3>
              <strong>@Model.Cart.Total</strong>
            </h3>
        </td>
    </tr>
    <tr>
        <td></td>
        <td></td>
        <td></td>
        <td>
            <a asp-controller="Product" asp-action="Index" class="btn btn-sm btn-outline-secondary">
                <span>Continue Shopping</span>
            </a>
        </td>  <td>
            <a asp-controller="Cart" asp-action="Complete" class="btn btn-sm btn-outline-secondary">
                <span>Go To Checkout</span>
            </a>
        </td>
    </tr>
</table>